Description

This allows Object#clone to not freeze the resulting object, which fixes a long standing problem in ruby in that you cannot get an

unfrozen copy of an object that includes a copy of the object's singleton class. Previously, clone always returned a frozen object, and

dup did not copy the singleton class.  This adds the ability to get an unfrozen clone of an object that includes a copy of the object's

singleton class, allowing further modification.

Among other things, this allows the ability to create modified clones of objects that have singleton classes:

class A

  def clone(arg)

    obj = super(freeze: false)

    # modify obj based on arg

    obj.freeze

  end

end

 I think this is a simpler and more flexible approach to the same problem that #12092 tries to solve.

Associated revisions

Revision 320ae01c5fb091eab0926c186f304a9caeda1ace - 08/01/2016 05:55 AM - shyouhei (Shyouhei Urabe)

Object#clone with freeze: false [Feature #12300]

    * object.c (rb_obj_clone2): Allow Object#clone to take freeze:

      false keyword argument to not freeze the clone.

      [ruby-core:75017][Feature #12300]

    * test/ruby/test_object.rb (TestObject): test for it.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55786 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 320ae01c - 08/01/2016 05:55 AM - shyouhei (Shyouhei Urabe)

Object#clone with freeze: false [Feature #12300]

    * object.c (rb_obj_clone2): Allow Object#clone to take freeze:

      false keyword argument to not freeze the clone.

      [ruby-core:75017][Feature #12300]

    * test/ruby/test_object.rb (TestObject): test for it.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55786 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e821f974511fc7577f467f6178ccf2de99e355b2 - 08/03/2016 08:15 AM - nobu (Nobuyoshi Nakada)

object.c: restrict freeze option

object.c (rb_obj_clone2): restrict freeze option to true other

than false which only has the effect.  [Feature #12300]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55808 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e821f974 - 08/03/2016 08:15 AM - nobu (Nobuyoshi Nakada)

object.c: restrict freeze option

object.c (rb_obj_clone2): restrict freeze option to true other

than false which only has the effect.  [Feature #12300]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55808 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 340805cfad9ca5072ab79cdbc1cf00b98c764caf - 08/03/2016 08:20 AM - nobu (Nobuyoshi Nakada)

NEWS: Kernel#clone [ci skip]

NEWS (Kernel#clone): mention freeze flag.  [Feature #12300]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55809 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 340805cf - 08/03/2016 08:20 AM - nobu (Nobuyoshi Nakada)

NEWS: Kernel#clone [ci skip]

NEWS (Kernel#clone): mention freeze flag.  [Feature #12300]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55809 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 04/20/2016 01:35 AM - shyouhei (Shyouhei Urabe)

Sounds much simpler than the previous one to understand what is happening.  Also it seems backwards-compatible.

Given the needs of this kind, I'd like to +1.

#2 - 07/19/2016 05:47 AM - matz (Yukihiro Matsumoto)

Sounds reasonable.

Matz.

#3 - 08/01/2016 05:55 AM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Closed

Applied in changeset r55786.

Object#clone with freeze: false [Feature #12300]

* object.c (rb_obj_clone2): Allow Object#clone to take freeze:

  false keyword argument to not freeze the clone.

  [ruby-core:75017][Feature #12300]

* test/ruby/test_object.rb (TestObject): test for it.

Files
